#include "global.h"   // client_connected()
#include "lwip/tcp.h" // tcp_new(),tcp_connect()
#include "lwip/pbuf.h"

#ifdef CLIENT

static const int client_close = CLIENT_CLOSE;

int client_init(const unsigned char remote_ip[4], short int remote_port)
{
	struct tcp_pcb *pcb = NULL;
	err_t ret_code = ERR_OK;
	struct ip_addr remote_ipaddr;

	pcb = tcp_new();
	if(NULL == pcb) {
		print("tcp_new(): echec.\n\r");
		return -1;
	}
	
	tcp_arg(pcb, (void *)&client_close);
	tcp_err(pcb, client_err);

	IP4_ADDR(&remote_ipaddr, remote_ip[0], remote_ip[1], remote_ip[2], remote_ip[3]);

	ret_code = tcp_connect(pcb, &remote_ipaddr, remote_port, client_connected);
	if(ERR_OK != ret_code) {
		print("tcp_connect(): echec.\n\r");
		return -1;
	}

	return 0;
}

#endif //CLIENT
