#ifndef __CONFIG_H__
#define __CONFIG_H__

#include "xparameters.h"

//! Dfinir cette macro s'il on souhaite activer le serveur.
#define SERVER

//! Dfinir cette macro s'il on souhaite activer le client.
#define CLIENT

//! Dfinir cette macro s'il on souhaite activer l'interface LoopBack (et dsactiver l'interface Xemac).
#define LOOPBACK

//! Macro spcifiant si le serveur doit fermer la connexion lors du premier envoie (utile pour du HTTP).
#define SERVER_CLOSE 0

//! Macro spcifiant si le client doit fermer la connexion lors du premier envoie.
#define CLIENT_CLOSE 0

//! Adresse MAC du FPGA.
#define LOCAL_MAC     {0x00, 0x01, 0x02, 0x03, 0x04, 0x05}

//! Adresse IP du FPGA.
#define LOCAL_IP      {192, 168, 1, 133}

//! Masque sous-rseau pour le FPGA.
#define LOCAL_SUBNET  {255, 255, 255, 0}

//! Passerelle pour le FPGA.
#define LOCAL_GATEWAY {192, 168, 1, 254}

//! Port TCP d'coute du serveur du FPGA.
#define LOCAL_PORT    80

//! Adresse IP serveur distant.
#define REMOTE_IP     {192, 168, 1, 132}

//! Port d'coute du serveur distant.
#define REMOTE_PORT   80

//! Nombre de secondes entre chaque envoie du client.
#define POLL_INTERVAL 5

//! Numro de l'emac
#define EMAC XPAR_ETHERNET_MAC_DEVICE_ID

//!
//#define LOOP

//! Numro de l
//#define SLIP XPAR_OPB_UARTLITE_0_DEVICE_ID

/***********************************
 * Equivalence XEmac <-> XEmacLite *
 ***********************************/

#ifdef XPAR_XEMAC_NUM_INSTANCES

#define XEmacLiteIf_Config      XEmacIf_Config
#define XEmacLiteIf_ConfigTable XEmacIf_ConfigTable 
#define xemacliteif_setmac      xemacif_setmac
#define xemacliteif_init        xemacif_init   
#define xemacliteif_input       xemacif_input

#endif

/*****************************
 * VERIFICATION DE COHERENCE *
 *****************************/

#if defined(EMAC) & defined(SLIP)
#error EMAC et SLIP dfinis en mme temps !
#endif

#if defined(EMAC) & defined(LOOP)
#error EMAC et LOOP dfinis en mme temps !
#endif

#if defined(SLIP) & defined(LOOP)
#error SLIP et LOOP dfinis en mme temps !
#endif

#endif //__CONFIG_H__
