#include "global.h"   // XEmacIF_ConfigTable[]

#ifdef LOOPBACK
extern err_t loopif_init(struct netif *netif);
#endif

struct netif *lwip_config(const unsigned char mac[6], const unsigned char ip[4],
		const unsigned char subnet[4], const unsigned char gateway[4])
{
	struct ip_addr ipaddr;
	struct ip_addr netmask;
	struct ip_addr gw;
	struct netif *netif = NULL;

#ifdef EMAC
	xemacliteif_setmac(0, (u8_t *)mac);
#endif
	
	IP4_ADDR(&ipaddr, ip[0], ip[1], ip[2], ip[3]);
	IP4_ADDR(&netmask, subnet[0], subnet[1], subnet[2], subnet[3]);
	IP4_ADDR(&gw, gateway[0], gateway[1], gateway[2], gateway[3]);

	netif = mem_malloc(sizeof(struct netif));
	if(NULL == netif) {
		print("mem_alloc(): echec.\n\r");
		return NULL;
	}

#ifdef LOOP
	netif = netif_add(netif, &ipaddr, &netmask, &gw, NULL, loopif_init, ip_input);
#endif
#ifdef EMAC
	netif = netif_add(netif, &ipaddr, &netmask, &gw, &XEmacLiteIf_ConfigTable[EMAC], xemacliteif_init, ip_input);
#endif
#ifdef SLIP
netif = netif_add(netif, &ipaddr, &netmask, &gw, SLIP, slipif_init, ip_input);
#endif

	if(NULL == netif) {
		print("netif_add(): echec.\n\r");
		return NULL;
	}


	netif_set_default(netif);

	return netif;
}
