#include "global.h"   // init_lwip(), config_lwip()
#include "config.h"   // LOCAL_*
#include "xcache_l.h" // XCache_EnableICache(), XCache_EnableDCache()

int main(void)
{
	const unsigned char mac[6]     = LOCAL_MAC;
	const unsigned char ip[4]      = LOCAL_IP;
	const unsigned char subnet[4]  = LOCAL_SUBNET;
	const unsigned char gateway[4] = LOCAL_GATEWAY;

#ifdef SERVER
const short int port     = LOCAL_PORT;
#endif
#ifdef CLIENT
	const unsigned char remote_ip[4] = REMOTE_IP;
	const short int remote_port      = REMOTE_PORT;
#endif //CLIENT

	struct netif *netif = NULL;
	int ret_code = 0;

	// efface l'cran
	print("\033[H\033[J");

	lwip_init();
	print("Initialisation de lwIP : OK\n\r");

	netif = lwip_config(mac, ip, subnet, gateway);
	if(NULL == netif)
		return -1;
	else 
		print("Configuration de lwIP : OK\n\r");

	xil_printf("\t@ MAC   : %x:%x:%x:%x:%x:%x\n\r", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
	xil_printf("\t@ IP    : %d.%d.%d.%d\n\r", ip[0], ip[1], ip[2], ip[3]);
	xil_printf("\tNetmask : %d.%d.%d.%d\n\r", subnet[0], subnet[1], subnet[2], subnet[3]);
	xil_printf("\tGateway : %d.%d.%d.%d\n\r", gateway[0], gateway[1], gateway[2], gateway[3]);

#ifdef SERVER
	ret_code = server_init(port);
	if(0 != ret_code)
		return -1;
	else 
		print("Initialisation du serveur : OK\n\r");

	xil_printf("\tPort    : %d\n\r", port);
#endif //SERVER

#ifdef CLIENT
	ret_code = client_init(remote_ip, remote_port);
	if(0 != ret_code)
		return -1;
	else 
		print("Initialisation du client : OK\n\r");

	xil_printf("\t@ IP distante : %d.%d.%d.%d\n\r", remote_ip[0], remote_ip[1], remote_ip[2], remote_ip[3]);
	xil_printf("\tPort distant  : %d\n\r", remote_port);
#endif //CLIENT

	run(netif);

	// jamais atteint !
	return 0;
}
