#include "xtime_l.h"       // Xtime_*
#include "global.h"        // print()
#include "lwip/tcp.h"      // tcp_tmr()

#ifdef XPAR_XEMAC_NUM_INSTANCES
#include "netif/xemacif.h" // struct netif
#else
#include "netif/xemacliteif.h" // struct netif
#endif

void run(struct netif *netif)
{
	XTime timer = 0;
	XTime timer_cycles = 0;
	long int ratio_etharp = 0;
	
	timer_cycles = TCP_TMR_INTERVAL * (XPAR_CPU_PPC405_CORE_CLOCK_FREQ_HZ / 1000);
	ratio_etharp = ARP_TMR_INTERVAL / TCP_TMR_INTERVAL;

	print("Systeme : ready !\n\r");

	XTime_SetTime(0);

	while(1) {
		XTime_GetTime(&timer);

		if(timer < timer_cycles) {
#ifdef EMAC
			xemacliteif_input(netif);
#endif
#ifdef SLIP
			netif->input(slipif_input(netif), netif);
#endif
		} else {
			XTime_SetTime(0);
			timer = 0;
			tcp_tmr();
#ifdef EMAC
			ratio_etharp = ratio_etharp - 1;
			if(0 == ratio_etharp) {
				ratio_etharp = ARP_TMR_INTERVAL / TCP_TMR_INTERVAL;
				etharp_tmr();
			}
#endif
		}
	}
}
