#include "config.h"   // DEFAULT_PORT
#include "global.h"   // server_accept()
#include "lwip/tcp.h" // tcp_new(), tcp_bind(), tcp_listen(), tcp_accept()

#ifdef SERVER

static const int server_close = SERVER_CLOSE;

int server_init(short int port)
{
	struct tcp_pcb *pcb = NULL;
	err_t ret_code = ERR_OK;

	pcb = tcp_new();
	if(NULL == pcb) {
		print("tcp_new(): echec.\n\r");
		return -1;
	}

	tcp_arg(pcb, (void *)&server_close);
	tcp_err(pcb, server_err);

	ret_code = tcp_bind(pcb, NULL, port);
	if(ERR_OK != ret_code) {
		print("tcp_bind(): echec.\n\r");
		return -1;
	}

	pcb = tcp_listen(pcb);
	if(NULL == pcb) {
		print("tcp_listen(): echec.\n\r");
		return -1;
	}

	tcp_accept(pcb, server_accept);

	return 0;
}

#endif //SERVER
